rules:
  - id: glappsec_insecure-archive-go
    patterns:
      - pattern-inside:
          pattern-either:
            - pattern: |
                import "archive/zip"
                ...
            - pattern: |
                import $ZIP "archive/zip"
                ...
      - pattern-inside: |
          func $FUNC($SRC, $DEST string) {
            zip.OpenReader(...)
            ...
            os.MkdirAll($DEST, ...)
            ...
            os.$METHOD(..., $ARG, ...)
            ...
          }
      - pattern-not-inside: >
          func $FUNC($SRC, $DEST string) {
            ...
            if !strings.HasPrefix(..., filepath.Clean($DEST) + string(os.PathSeparator)) {
            ...
            }
            ...
          }
      - pattern: os.$METHOD(..., $ARG, ...)
      - metavariable-regex:
          metavariable: $METHOD
          regex: (OpenFile|MkdirAll)
      - focus-metavariable: $ARG
    metadata:
      confidence: LOW
      references:
        - https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#working-with-archive-files
      vulnerability_class:
        - Zip Slip
    message: >
      Potential zip slip attack detected. Make sure that the path name of 
      unzipped files are sanitized before passing it to `os` functions. 
      Consult Gitlab's secure coding guidelines for more information: 
      https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#working-with-archive-files"
    languages:
      - go
    severity: ERROR
